/*
 * Erstellt mit SharpDevelop.
 * Benutzer: Dirk Paehl (http://www.paehl.com)
 * Datum: 04.03.2007
 * Zeit: 18:35
 * 
 * This program run under the GPL (GNU Gerneral Public License)
 */

using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.IO;

namespace JkDefragGui
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		[STAThread]
		public static void Main(string[] args)
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			Application.Run(new MainForm());
		}
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
	
		void Button1Click(object sender, EventArgs e)
		{
		 
			if (checkdisk.Checked)
			{
			  string path1 = Application.ExecutablePath;
			  string aPath1 = System.IO.Path.GetDirectoryName(path1)+ @"\checkDisk.exe";
			  if (File.Exists(aPath1))
			   {
			   	 Process checkd = new Process();
                 checkd.StartInfo.FileName = aPath1;
                 checkd.StartInfo.UseShellExecute = false;
                 checkd.StartInfo.RedirectStandardOutput = true;
                 checkd.Start();    
                 checkd.WaitForExit();
			   }
					
				
			}
		string parameter="";
         if (radioButton1.Checked) parameter = "-a 1 "; else
         if (radioButton2.Checked) parameter = "-a 2 "; else	
         if (radioButton3.Checked) parameter = "-a 3 "; else
         if (radioButton4.Checked) parameter = "-a 4 "; else 
         if (radioButton13.Checked) parameter = "-a 5 "; else
         if (radioButton12.Checked) parameter = "-a 6 "; else
         if (radioButton14.Checked) parameter = "  "; else         	
         if (radioButton15.Checked) parameter = "-a 4  ";         	
         	
         if (checkBox1.Checked) parameter += "-e "+mask.Text+" ";	

         if (radioButton5.Checked) parameter += "-d 0 "; else
         if (radioButton6.Checked) parameter += "-d 1 "; else	
         if (radioButton7.Checked) parameter += "-d 2 "; else
         if (radioButton8.Checked) parameter += "-d 3 "; else	         	
         if (radioButton9.Checked) parameter += "-d 4 "; else	         	
         if (radioButton10.Checked) parameter += "-d 5 "; else	         	         	
         if (radioButton11.Checked) parameter += "-d 6 ";
         
         if (comboBox1.Text=="Self define") parameter +=self_define.Text; else
         if (!all_drives.Checked) parameter +=comboBox1.Text;
		  
         this.WindowState = FormWindowState.Minimized;
      
		 
          string path = Application.ExecutablePath;
		  string aPath = System.IO.Path.GetDirectoryName(path)+ @"\JKDefrag.exe";
          Process compiler = new Process();
          compiler.StartInfo.FileName = aPath;
          compiler.StartInfo.Arguments = parameter;
          compiler.StartInfo.UseShellExecute = false;
          compiler.StartInfo.RedirectStandardOutput = true;
          compiler.Start();    
          compiler.WaitForExit();
          
          //if (radioButton1.Checked)
          //{
            aPath = System.IO.Path.GetDirectoryName(path)+ @"\JkDefrag.log";
            string commandText = "notepad.exe" ;
            System.Diagnostics.Process proc = new System.Diagnostics.Process();
            proc.StartInfo.FileName = commandText;
            proc.StartInfo.Arguments=aPath;
            proc.StartInfo.UseShellExecute = true;
            proc.Start();          
          //} //Only for analyse
          
          if ((radioButton4.Checked) || (radioButton15.Checked))
          {
          string DATEINAME = System.IO.Path.GetDirectoryName(path)+ @"\jkdefrag.conf";
          StreamWriter sr = File.CreateText(DATEINAME);
          sr.WriteLine (DateTime.Now.ToLongDateString());
          sr.Close();
          }
          this.WindowState = FormWindowState.Normal;
		}
		
		public string ReadLine(String sFilename, int iLine)
    {
        string sContent = "";
        float fRow=0;
        if (File.Exists(sFilename))
        {
            StreamReader myFile = new StreamReader(sFilename, System.Text.Encoding.Default);
            while (! myFile.EndOfStream && fRow < iLine)
            {
                fRow++;
                sContent = myFile.ReadLine(); 
            }
            myFile.Close();
            if(fRow < iLine) 
                sContent = "";
        }
        return sContent;
    }

		void MainFormLoad(object sender, EventArgs e)
		{
         string[] drivesList = System.IO.Directory.GetLogicalDrives();
         foreach (string drive in drivesList)
          {
            System.IO.DriveInfo di = new System.IO.DriveInfo(drive);
            if (di.DriveType == System.IO.DriveType.Removable || di.DriveType == System.IO.DriveType.Fixed)
            {
            	if (di.IsReady) 
            	comboBox1.Items.Add(drive.ToString());
            }
          }
          comboBox1.SelectedIndex=0;         
          comboBox1.Items.Add("Self define");
          string path = Application.ExecutablePath;
          string DATEINAME = System.IO.Path.GetDirectoryName(path)+ @"\jkdefrag.conf";
          string last=ReadLine(DATEINAME,1);
          last = last.Replace("ä", ""); //The german umlaut 
          label1.Text="Last full defrag: \n"+last; 
          DATEINAME = System.IO.Path.GetDirectoryName(path)+ @"\jkgui.conf";
          mask.Text=ReadLine(DATEINAME,1);
          self_define.Text=ReadLine(DATEINAME,2);
          last=ReadLine(DATEINAME,3);
          if (last == "True" ) checkBox2.Checked=true; else checkBox2.Checked=false;
          string path1 = Application.ExecutablePath;
		  string aPath1 = System.IO.Path.GetDirectoryName(path1)+ @"\checkDisk.exe";
		  if (File.Exists(aPath1))
			  	checkdisk.Visible=true; else
			  	checkdisk.Visible=false; 
		}
		
		
		
		void Button2Click(object sender, EventArgs e)
		{
		  
		  string path = Application.ExecutablePath;
		  string DATEINAME = System.IO.Path.GetDirectoryName(path)+ @"\jkgui.conf";
          StreamWriter sr = File.CreateText(DATEINAME);
          sr.WriteLine (mask.Text);
          sr.WriteLine (self_define.Text);
          sr.WriteLine (checkBox2.Checked);
          sr.Close();
			Close();
		}
		
		void LOGCheckedChanged(object sender, EventArgs e)
		{
			
			if (!LOG.Checked)
			{
			  Size = new Size (315,363);
			} else
			{
			  Size = new Size (523,363);
			}
		}
		
	
		
		void ComboBox1SelectedIndexChanged(object sender, EventArgs e)
		{
			if (comboBox1.Text=="Self define") self_define.Visible=true; else
				self_define.Visible=false;
		}
		
		void Button3Click(object sender, EventArgs e)
		{
			if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
			{
				comboBox1.Text="Self define";
				self_define.Text="\""+folderBrowserDialog1.SelectedPath+"\"";
			}
		}
		
		
		
		void CheckBox2CheckedChanged(object sender, EventArgs e)
		{
			if (checkBox2.Checked)
			{
				radioButton1.Visible =false;
				radioButton2.Visible =false;
				radioButton3.Visible =false;
				radioButton4.Visible =false;
				radioButton12.Visible =false;
				radioButton13.Visible =false;
				radioButton1.Checked=false;
				radioButton14.Checked=true;
			} else
			{
				radioButton1.Visible =true;
				radioButton2.Visible =true;
				radioButton3.Visible =true;
				radioButton4.Visible =true;
				radioButton12.Visible =true;
				radioButton13.Visible =true;
                radioButton14.Checked=false;
				radioButton1.Checked=true;
			}
		}
	}
}
